#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"BiosCharacteristics",;
"BIOSVersion",;
"BuildNumber",;
"Caption",;
"CodeSet",;
"CurrentLanguage",;
"Description",;
"IdentificationCode",;
"InstallableLanguages",;
"InstallDate",;
"LanguageEdition",;
"ListOfLanguages",;
"Manufacturer",;
"Name",;
"OtherTargetOS",;
"PrimaryBIOS",;
"ReleaseDate",;
"SerialNumber",;
"SMBIOSBIOSVersion",;
"SMBIOSMajorVersion",;
"SMBIOSMinorVersion",;
"SMBIOSPresent",;
"SoftwareElementID",;
"SoftwareElementState",;
"Status",;
"TargetOperatingSystem" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_BIOS.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_BIOS",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("BiosCharacteristics"),;
     oService:getProperty("BIOSVersion"),;
     oService:getProperty("BuildNumber"),;
     oService:getProperty("Caption"),;
     oService:getProperty("CodeSet"),;
     oService:getProperty("CurrentLanguage"),;
     oService:getProperty("Description"),;
     oService:getProperty("IdentificationCode"),;
     oService:getProperty("InstallableLanguages"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("LanguageEdition"),;
     oService:getProperty("ListOfLanguages"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("Name"),;
     oService:getProperty("OtherTargetOS"),;
     oService:getProperty("PrimaryBIOS"),;
     oService:getProperty("ReleaseDate"),;
     oService:getProperty("SerialNumber"),;
     oService:getProperty("SMBIOSBIOSVersion"),;
     oService:getProperty("SMBIOSMajorVersion"),;
     oService:getProperty("SMBIOSMinorVersion"),;
     oService:getProperty("SMBIOSPresent"),;
     oService:getProperty("SoftwareElementID"),;
     oService:getProperty("SoftwareElementState"),;
     oService:getProperty("Status"),;
     oService:getProperty("TargetOperatingSystem") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_BIOS.TXT","Notepad.exe",.T.)

RETURN
