#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"Access",;
"Availability",;
"BlockSize",;
"Caption",;
"Compressed",;
"ConfigManagerErrorCode",;
"ConfigManagerUserConfig",;
"CreationClassName",;
"Description",;
"DeviceID",;
"DriveType",;
"ErrorCleared",;
"ErrorDescription",;
"ErrorMethodology",;
"FileSystem",;
"FreeSpace",;
"InstallDate",;
"LastErrorCode",;
"MaximumComponentLength",;
"MediaType",;
"Name",;
"NumberOfBlocks",;
"PNPDeviceID",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"ProviderName",;
"Purpose",;
"QuotasDisabled",;
"QuotasIncomplete",;
"QuotasRebuilding",;
"Size",;
"Status",;
"StatusInfo",;
"SupportsDiskQuotas",;
"SupportsFileBasedCompression",;
"SystemCreationClassName",;
"SystemName",;
"VolumeDirty",;
"VolumeName" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_LogicalDisk.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_LogicalDisk",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("Access"),;
     oService:getProperty("Availability"),;
     oService:getProperty("BlockSize"),;
     oService:getProperty("Caption"),;
     oService:getProperty("Compressed"),;
     oService:getProperty("ConfigManagerErrorCode"),;
     oService:getProperty("ConfigManagerUserConfig"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("Description"),;
     oService:getProperty("DeviceID"),;
     oService:getProperty("DriveType"),;
     oService:getProperty("ErrorCleared"),;
     oService:getProperty("ErrorDescription"),;
     oService:getProperty("ErrorMethodology"),;
     oService:getProperty("FileSystem"),;
     oService:getProperty("FreeSpace"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("LastErrorCode"),;
     oService:getProperty("MaximumComponentLength"),;
     oService:getProperty("MediaType"),;
     oService:getProperty("Name"),;
     oService:getProperty("NumberOfBlocks"),;
     oService:getProperty("PNPDeviceID"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("ProviderName"),;
     oService:getProperty("Purpose"),;
     oService:getProperty("QuotasDisabled"),;
     oService:getProperty("QuotasIncomplete"),;
     oService:getProperty("QuotasRebuilding"),;
     oService:getProperty("Size"),;
     oService:getProperty("Status"),;
     oService:getProperty("StatusInfo"),;
     oService:getProperty("SupportsDiskQuotas"),;
     oService:getProperty("SupportsFileBasedCompression"),;
     oService:getProperty("SystemCreationClassName"),;
     oService:getProperty("SystemName"),;
     oService:getProperty("VolumeDirty"),;
     oService:getProperty("VolumeName") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_LogicalDisk.TXT","Notepad.exe",.T.)

RETURN
