#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"AccessMask",;
"Caption",;
"Comment",;
"ConnectionState",;
"ConnectionType",;
"Description",;
"DisplayType",;
"InstallDate",;
"LocalName",;
"Name",;
"Persistent",;
"ProviderName",;
"RemoteName",;
"RemotePath",;
"ResourceType",;
"Status" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_NetworkConnection.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_NetworkConnection",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("AccessMask"),;
     oService:getProperty("Caption"),;
     oService:getProperty("Comment"),;
     oService:getProperty("ConnectionState"),;
     oService:getProperty("ConnectionType"),;
     oService:getProperty("Description"),;
     oService:getProperty("DisplayType"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("LocalName"),;
     oService:getProperty("Name"),;
     oService:getProperty("Persistent"),;
     oService:getProperty("ProviderName"),;
     oService:getProperty("RemoteName"),;
     oService:getProperty("RemotePath"),;
     oService:getProperty("ResourceType"),;
     oService:getProperty("Status") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_NetworkConnection.TXT","Notepad.exe",.T.)

RETURN
