#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"AdminPasswordStatus",;
"AutomaticResetBootOption",;
"AutomaticResetCapability",;
"BootOptionOnLimit",;
"BootOptionOnWatchDog",;
"BootROMSupported",;
"BootupState",;
"Caption",;
"ChassisBootupState",;
"CreationClassName",;
"CurrentTimeZone",;
"DaylightInEffect",;
"Description",;
"Domain",;
"DomainRole",;
"EnableDaylightSavingsTime",;
"FrontPanelResetStatus",;
"InfraredSupported",;
"InitialLoadInfo",;
"InstallDate",;
"KeyboardPasswordStatus",;
"LastLoadInfo",;
"Manufacturer",;
"Model",;
"Name",;
"NameFormat",;
"NetworkServerModeEnabled",;
"NumberOfProcessors",;
"OEMLogoBitmap",;
"OEMStringArray",;
"PartOfDomain",;
"PauseAfterReset",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"PowerOnPasswordStatus",;
"PowerState",;
"PowerSupplyState",;
"PrimaryOwnerContact",;
"PrimaryOwnerName",;
"ResetCapability",;
"ResetCount",;
"ResetLimit",;
"Roles",;
"Status",;
"SupportContactDescription",;
"SystemStartupDelay",;
"SystemStartupOptions",;
"SystemStartupSetting",;
"SystemType",;
"ThermalState",;
"TotalPhysicalMemory",;
"UserName",;
"WakeUpType" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_ComputerSystem.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_ComputerSystem",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("AdminPasswordStatus"),;
     oService:getProperty("AutomaticResetBootOption"),;
     oService:getProperty("AutomaticResetCapability"),;
     oService:getProperty("BootOptionOnLimit"),;
     oService:getProperty("BootOptionOnWatchDog"),;
     oService:getProperty("BootROMSupported"),;
     oService:getProperty("BootupState"),;
     oService:getProperty("Caption"),;
     oService:getProperty("ChassisBootupState"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("CurrentTimeZone"),;
     oService:getProperty("DaylightInEffect"),;
     oService:getProperty("Description"),;
     oService:getProperty("Domain"),;
     oService:getProperty("DomainRole"),;
     oService:getProperty("EnableDaylightSavingsTime"),;
     oService:getProperty("FrontPanelResetStatus"),;
     oService:getProperty("InfraredSupported"),;
     oService:getProperty("InitialLoadInfo"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("KeyboardPasswordStatus"),;
     oService:getProperty("LastLoadInfo"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("Model"),;
     oService:getProperty("Name"),;
     oService:getProperty("NameFormat"),;
     oService:getProperty("NetworkServerModeEnabled"),;
     oService:getProperty("NumberOfProcessors"),;
     oService:getProperty("OEMLogoBitmap"),;
     oService:getProperty("OEMStringArray"),;
     oService:getProperty("PartOfDomain"),;
     oService:getProperty("PauseAfterReset"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("PowerOnPasswordStatus"),;
     oService:getProperty("PowerState"),;
     oService:getProperty("PowerSupplyState"),;
     oService:getProperty("PrimaryOwnerContact"),;
     oService:getProperty("PrimaryOwnerName"),;
     oService:getProperty("ResetCapability"),;
     oService:getProperty("ResetCount"),;
     oService:getProperty("ResetLimit"),;
     oService:getProperty("Roles"),;
     oService:getProperty("Status"),;
     oService:getProperty("SupportContactDescription"),;
     oService:getProperty("SystemStartupDelay"),;
     oService:getProperty("SystemStartupOptions"),;
     oService:getProperty("SystemStartupSetting"),;
     oService:getProperty("SystemType"),;
     oService:getProperty("ThermalState"),;
     oService:getProperty("TotalPhysicalMemory"),;
     oService:getProperty("UserName"),;
     oService:getProperty("WakeUpType") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_ComputerSystem.TXT","Notepad.exe",.T.)

RETURN
