#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"AdapterType",;
"AdapterTypeId",;
"AutoSense",;
"Availability",;
"Caption",;
"ConfigManagerErrorCode",;
"ConfigManagerUserConfig",;
"CreationClassName",;
"Description",;
"DeviceID",;
"ErrorCleared",;
"ErrorDescription",;
"Index",;
"InstallDate",;
"Installed",;
"LastErrorCode",;
"MACAddress",;
"Manufacturer",;
"MaxNumberControlled",;
"MaxSpeed",;
"Name",;
"NetConnectionID",;
"NetConnectionStatus",;
"NetworkAddresses",;
"PermanentAddress",;
"PNPDeviceID",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"ProductName",;
"ServiceName",;
"Speed",;
"Status",;
"StatusInfo",;
"SystemCreationClassName",;
"SystemName" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_NetworkAdapter.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_NetworkAdapter",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("AdapterType"),;
     oService:getProperty("AdapterTypeId"),;
     oService:getProperty("AutoSense"),;
     oService:getProperty("Availability"),;
     oService:getProperty("Caption"),;
     oService:getProperty("ConfigManagerErrorCode"),;
     oService:getProperty("ConfigManagerUserConfig"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("Description"),;
     oService:getProperty("DeviceID"),;
     oService:getProperty("ErrorCleared"),;
     oService:getProperty("ErrorDescription"),;
     oService:getProperty("Index"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("Installed"),;
     oService:getProperty("LastErrorCode"),;
     oService:getProperty("MACAddress"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("MaxNumberControlled"),;
     oService:getProperty("MaxSpeed"),;
     oService:getProperty("Name"),;
     oService:getProperty("NetConnectionID"),;
     oService:getProperty("NetConnectionStatus"),;
     oService:getProperty("NetworkAddresses"),;
     oService:getProperty("PermanentAddress"),;
     oService:getProperty("PNPDeviceID"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("ProductName"),;
     oService:getProperty("ServiceName"),;
     oService:getProperty("Speed"),;
     oService:getProperty("Status"),;
     oService:getProperty("StatusInfo"),;
     oService:getProperty("SystemCreationClassName"),;
     oService:getProperty("SystemName") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_NetworkAdapter.TXT","Notepad.exe",.T.)

RETURN
